## molmodel 3.0~svn842

=== CMakeLists.txt ===
#---------------------------------------------------

# Molmodel 

#

# Creates SimTK library, base name=SimTKmolmodel.

# Default libraries are shared & optimized. Variants

# are created for static (_static) and debug (_d) and

# provision is made for an optional "namespace" (ns)

# and version number (vn).

#

# Windows:

#   [ns_]SimTKmolmodel[_vn][_d].dll

#   [ns_]SimTKmolmodel[_vn][_d].lib

#   [ns_]SimTKmolmodel[_vn]_static[_d].lib

# Unix:

#   lib[ns_]SimTKmolmodel[_vn][_d].so

#   lib[ns_]SimTKmolmodel[_vn]_static[_d].a

#

# All libraries are installed in 

#   %ProgramFiles%\SimTK\lib    (Windows)

#   /usr/local/SimTK/lib[64]    (Linux, Mac)

#

# Also creates an OpenMM plugin DLL that is used at

# runtime to determine whether OpenMM is available.

# That DLL is named

#   OpenMMPlugin[_d].dll

#   libOpenMMPlugin[_d].so

#   libOpenMMPlugin[_d].dylib

# And there is no static version.

#----------------------------------------------------



cmake_minimum_required(VERSION 2.8)



project(Molmodel)



set(MOLMODEL_MAJOR_VERSION 3)

set(MOLMODEL_MINOR_VERSION 0)

set(MOLMODEL_PATCH_VERSION 0)



set(MOLMODEL_COPYRIGHT_YEARS "2006-12")



# underbar separated list of dotted authors, no spaces or commas

set(MOLMODEL_AUTHORS "Christopher.Bruns_Michael.Sherman")



# Report the version number to the CMake UI. Don't include the 

# build version if it is zero.

set(PATCH_VERSION_STRING)

IF(MOLMODEL_PATCH_VERSION)

    SET(PATCH_VERSION_STRING ".${MOLMODEL_PATCH_VERSION}")

ENDIF()



set(MOLMODEL_VERSION 

    "${MOLMODEL_MAJOR_VERSION}.${MOLMODEL_MINOR_VERSION}${PATCH_VERSION_STRING}"

    CACHE STRING 

    "This is the version that will be built (can't be changed here)." 

    FORCE)

#set(MOLMODEL_SONAME_VERSION
#    "${MOLMODEL_MAJOR_VERSION}.${MOLMODEL_MINOR_VERSION}"
#    CACHE STRING
#    "Soname version; appended to names of shared libs
#    (can't be changed in GUI)."
#    FORCE)

#set(SONAME
#    "${MOLMODEL_MAJOR_VERSION}.${MOLMODEL_MINOR_VERSION}"
#    CACHE STRING
#    "Soname version; appended to names of shared libs
#    (can't be changed in GUI)."
#    FORCE)



# This is the suffix if we're building and depending on versioned libraries.

set(VN "_${MOLMODEL_VERSION}")



set(BUILD_BINARY_DIR ${CMAKE_BINARY_DIR}

    CACHE PATH 

    "The Molmodel build (not the install) puts all the libraries and executables together here (with /Release, etc. appended on some platforms).")



# Make everything go in the same binary directory. (These are CMake-defined

# variables.)

set(EXECUTABLE_OUTPUT_PATH ${BUILD_BINARY_DIR})

set(LIBRARY_OUTPUT_PATH ${BUILD_BINARY_DIR})



# Static libraries, tests, and examples won't be built unless this 

# is set.

SET(BUILD_STATIC_LIBRARIES FALSE CACHE BOOL

"Build '_static' versions of libraries in addition to dynamic libraries?")



# Use this to generate a private set of libraries whose names

# won't conflict with installed versions.

set(BUILD_USING_NAMESPACE "" CACHE STRING

	"All library names will be prefixed with 'xxx_' if this is set to xxx.")



set(BUILD_UNVERSIONED_LIBRARIES TRUE CACHE BOOL

 "Build library names, and assume dependency names, with no version numbers?")



set(BUILD_VERSIONED_LIBRARIES FALSE CACHE BOOL

 "Build library names, and assume dependency names, with version numbers?")



set(NS)

if(BUILD_USING_NAMESPACE)

    set(NS "${BUILD_USING_NAMESPACE}_")

endif()



set(MOLMODEL_LIBRARY_NAME ${NS}SimTKmolmodel CACHE STRING

"Base name of the library being built; can't be changed here; see BUILD_USING_NAMESPACE variable."

FORCE)





# Permit use of custom FindOpenMM and FindSimbody modules

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake_modules")



set(CMAKE_VERBOSE_MAKEFILE OFF CACHE BOOL "Control volume of build output" )



set(OpenMM_ON OFF)

find_package(OpenMM)

if(OpenMM_FOUND)

    set(OpenMM_ON ON)

endif()

set(MOLMODEL_USE_OpenMM ${OpenMM_ON} CACHE BOOL

    "Control whether Molmodel builds the OpenMM Plugin (requires that OpenMM is installed on the build machine)." )



# Caution: this variable is automatically created by the CMake

# ENABLE_TESTING() command, but we'll take it over here for

# our own purposes too.

set(BUILD_TESTING ON CACHE BOOL

	"Control building of Molmodel test programs." )



set(BUILD_EXAMPLES ON CACHE BOOL

	"Control building of Molmodel example programs." )



# Turning this off reduces the build time (and space) substantially,

# but you may miss the occasional odd bug. Also currently on Windows it

# is easier to debug the static tests than the DLL-liked ones.

SET( BUILD_TESTING_STATIC ON CACHE BOOL

    "If building static libraries, build static test and example programs too?" )



SET( BUILD_TESTING_SHARED ON CACHE BOOL

    "If building test or example programs, include dynamically-linked ones?" )



#

# Create a platform name useful for some platform-specific stuff.

IF(WIN32)

    SET(NATIVE_COPY_CMD copy)

ELSEIF(APPLE)

    SET(NATIVE_COPY_CMD cp)

ELSE()

    SET(NATIVE_COPY_CMD cp)

ENDIF()



# In addition to the platform name we need to know the Application Binary

# Interface (ABI) we're building for. Currently that is either x86, meaning

# 32 bit Intel instruction set, or x64 for 64 bit Intel instruction set.



IF(${CMAKE_SIZEOF_VOID_P} EQUAL 8)

    SET(PLATFORM_ABI x64)

ELSE()

    SET(PLATFORM_ABI x86)

ENDIF()



SET(BUILD_PLATFORM "${CMAKE_HOST_SYSTEM_NAME}:${PLATFORM_ABI}" CACHE STRING

    "This is the platform and ABI we're building for. Not changeable here; use a different CMake generator instead."

    FORCE)



# Find Simbody using the local FindSimbody.cmake if present.

find_package(Simbody REQUIRED)

include_directories(${Simbody_INCLUDE_DIR})

link_directories(${Simbody_LIB_DIR})



# If CMAKE_INSTALL_PREFIX is /usr/local, then the LIBDIR should necessarily be

# lib/. Sometimes (on Linux), LIBDIR is something like x86_64-linux-gnu. The

# linker will search /usr/lib/x86_64-linux-gnu (this path is in

# /etc/ld.so.conf.d), but it will NOT search /usr/local/lib/x86-64-linux-gnu.

# HOWEVER, it WILL search /usr/local/lib. So that Linux users needn't modify

# their LD_LIBRARY_PATH if installing to /usr/local, we force the LIBDIR to be

# lib/.

# Note: CMake 3.0 fixes this issue. When we move to CMake 3.0, we can

# remove this if-statement. See issue #151.

IF("${CMAKE_INSTALL_PREFIX}" STREQUAL "/usr/local" OR

        "${CMAKE_INSTALL_PREFIX}" STREQUAL "/usr/local/")

    # Overwrite both of these variables; we use both of them.

    SET(CMAKE_INSTALL_LIBDIR "lib")

    SET(CMAKE_INSTALL_FULL_LIBDIR

        "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")

ENDIF()





IF(NOT MSVC AND NOT XCODE AND NOT CMAKE_BUILD_TYPE)

    SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING 

        "Debug, RelWithDebInfo (recommended), or Release build" 

        FORCE)

ENDIF()



## Choose the maximum level of x86 instruction set that the compiler is 

## allowed to use. 

## Was using sse2 but changed to let the compilers choose. Most will

## probably use sse2 or later by default.

## On 64 bit MSVC 2013, the default is sse2 and the argument

## isn't recognized so don't specify it.

if (CMAKE_CL_64)

    set(default_build_inst_set)

else()

    set(default_build_inst_set)

endif()



## This can be set to a different value by the person running CMake.

SET(BUILD_INST_SET ""

    CACHE STRING 

    "CPU instruction level compiler is permitted to use (default: let compiler decide).")

MARK_AS_ADVANCED( BUILD_INST_SET )



if (BUILD_INST_SET)

    set(inst_set_to_use ${BUILD_INST_SET})

else()

    set(inst_set_to_use ${default_build_inst_set})

endif()



## When building in any of the Release modes, tell gcc/clang to use 

## not-quite most agressive optimization.  Here we 

## are specifying *all* of the Release flags, overriding CMake's defaults.

## Watch out for optimizer bugs in particular gcc versions!



IF(${CMAKE_CXX_COMPILER_ID} MATCHES "GNU" OR

   ${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")



    # If using either of these compilers, provide the option of 

    # compiling using the c++11 standard.

    OPTION(SIMBODY_STANDARD_11

        "Compile using the C++11 standard, if using GCC or Clang." ON)

    

    IF(${SIMBODY_STANDARD_11})

        # Using C++11 on OSX requires using libc++ instead of libstd++.

        # libc++ is an implementation of the C++ standard library for OSX.

        IF(APPLE)

            IF(XCODE)

                SET(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LANGUAGE_STANDARD "c++11")

                SET(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LIBRARY "libc++")

            ELSE()

                SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

                SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")

            ENDIF()

        ELSE() # not APPLE

            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

        ENDIF()

    ENDIF()



    if (inst_set_to_use)

        string(TOLOWER ${inst_set_to_use} GCC_INST_SET)

        set(GCC_INST_SET "-m${GCC_INST_SET}")

    else()

        set(GCC_INST_SET)

    endif()



    # Get the gcc or clang version number in major.minor.build format

    execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion

                    OUTPUT_VARIABLE GCC_VERSION)



    # Unrolling fixed-count loops was a useful optimization for Simmatrix

    # in earlier gcc versions.

    # Doesn't have a big effect for current compiler crop and may be 

    # pushing our luck with optimizer bugs. So let the compilers decide

    # how to handle loops instead.

    ##SET(GCC_OPT_ENABLE "-funroll-loops")



    # If you know of optimization bugs that affect Simbody in particular

    # gcc versions, this is the place to turn off those optimizations.

    SET(GCC_OPT_DISABLE)

    # We know Gcc 4.4.3 on Ubuntu 10 is buggy.

    IF(${CMAKE_CXX_COMPILER_ID} MATCHES "GNU")

      if (GCC_VERSION VERSION_EQUAL 4.4)

        SET(GCC_OPT_DISABLE 

        "-fno-strict-aliasing -fno-tree-vrp -fno-guess-branch-probability")

      endif()

    ENDIF()



    # C++

    SET(BUILD_CXX_FLAGS_DEBUG          "-g ${GCC_INST_SET}")

    SET(BUILD_CXX_FLAGS_RELEASE        

      "-DNDEBUG -O2 ${GCC_OPT_ENABLE} ${GCC_OPT_DISABLE} ${GCC_INST_SET}")

    SET(BUILD_CXX_FLAGS_RELWITHDEBINFO 

    "-DNDEBUG -O2 -g ${GCC_OPT_ENABLE} ${GCC_OPT_DISABLE} ${GCC_INST_SET}")

    SET(BUILD_CXX_FLAGS_MINSIZEREL     "-DNDEBUG -Os ${GCC_INST_SET}")



    # C

    SET(BUILD_C_FLAGS_DEBUG            "-g ${GCC_INST_SET}")

    SET(BUILD_C_FLAGS_RELEASE          

      "-DNDEBUG -O2 ${GCC_OPT_ENABLE} ${GCC_OPT_DISABLE} ${GCC_INST_SET}")

    SET(BUILD_C_FLAGS_RELWITHDEBINFO   

    "-DNDEBUG -O2 -g ${GCC_OPT_ENABLE} ${GCC_OPT_DISABLE} ${GCC_INST_SET}")

    SET(BUILD_C_FLAGS_MINSIZEREL       "-DNDEBUG -Os ${GCC_INST_SET}")



    # C++

    SET(CMAKE_CXX_FLAGS_DEBUG ${BUILD_CXX_FLAGS_DEBUG}

        CACHE STRING "Can't change here -- see BUILD_CXX..." FORCE)

    SET(CMAKE_CXX_FLAGS_RELEASE ${BUILD_CXX_FLAGS_RELEASE}

        CACHE STRING "Can't change here -- see BUILD_CXX..." FORCE)

    SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO ${BUILD_CXX_FLAGS_RELWITHDEBINFO}

        CACHE STRING "Can't change here -- see BUILD_CXX..." FORCE)

    SET(CMAKE_CXX_FLAGS_MINSIZEREL ${BUILD_CXX_FLAGS_MINSIZEREL}

        CACHE STRING "Can't change here -- see BUILD_CXX..." FORCE)



    # C

    SET(CMAKE_C_FLAGS_DEBUG ${BUILD_C_FLAGS_DEBUG}

        CACHE STRING "Can't change here -- see BUILD_C..." FORCE)

    SET(CMAKE_C_FLAGS_RELEASE ${BUILD_C_FLAGS_RELEASE}         

        CACHE STRING "Can't change here -- see BUILD_C..." FORCE)

    SET(CMAKE_C_FLAGS_RELWITHDEBINFO ${BUILD_C_FLAGS_RELWITHDEBINFO}

        CACHE STRING "Can't change here -- see BUILD_C..." FORCE)

    SET(CMAKE_C_FLAGS_MINSIZEREL ${BUILD_C_FLAGS_MINSIZEREL}

        CACHE STRING "Can't change here -- see BUILD_C..." FORCE)



ENDIF()

=== OpenMMPlugin/CMakeLists.txt ===
# Build the Molmodel OpenMM Plugin

find_package(OpenMM REQUIRED)
INCLUDE_DIRECTORIES(${OpenMM_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/src)

# The library is dependent on its local .cpp file and some of
# the Molmodel classes. We'll list everything to be safe.
ADD_LIBRARY(OpenMMPlugin SHARED 
	OpenMMPlugin.cpp
    ${SOURCE_INCLUDE_FILES} 
	${API_ABS_INCLUDE_FILES})
IF (UNIX AND CMAKE_BUILD_TYPE MATCHES Debug)
    set_target_properties(OpenMMPlugin PROPERTIES DEBUG_POSTFIX "_d")
ENDIF (UNIX AND CMAKE_BUILD_TYPE MATCHES Debug)

# The plugin depends on the OpenMM.dll that is part of
# the OpenMM distribution. 
TARGET_LINK_LIBRARIES(OpenMMPlugin
  ${SHARED_TARGET}			   # SimTKMolmodel.dll
  ${OpenMM_LIBRARIES})

SET_TARGET_PROPERTIES(OpenMMPlugin PROPERTIES
	PROJECT_LABEL "Plugin - OpenMMPlugin")

# Install the plugin with the Molmodel distribution; 
# on Windows both .lib and .dll go in the lib/plugins
# directory although the ".lib" should not be needed for
# a runtime-linked DLL.
INSTALL_TARGETS(/lib${LIB64}/plugins 
                RUNTIME_DIRECTORY /lib${LIB64}/plugins
                OpenMMPlugin)

=== examples/CMakeLists.txt ===
# Generate and install examples.
#
# This is boilerplate code for generating a set of executables, one per
# .cpp file in an "examples" subdirectory. These are intended to
# be installed with the library but we don't handle installation
# here. Unlike the similar boilerplate code in the "tests"
# directory (but like the "tests/adhoc" boilerplate), this does
# not generate CMake ADD_TEST commands so these will never run
# automatically.
#
# For IDEs that can deal with PROJECT_LABEL properties (at least
# Visual Studio) the projects for building each of these adhoc
# executables will be labeled "Example - TheExampleName" if a file
# TheExampleName.cpp is found in this directory.
#
# We check the BUILD_TESTING_{SHARED,STATIC} variables to determine
# whether to build dynamically linked, statically linked, or both
# versions of the executable.


FILE(GLOB EXAMPLES "*.cpp")
FOREACH(EX_PROG ${EXAMPLES})
    GET_FILENAME_COMPONENT(EX_SRC  ${EX_PROG} NAME)
    GET_FILENAME_COMPONENT(EX_ROOT ${EX_PROG} NAME_WE)

    IF (BUILD_TESTING_SHARED)
        # Link with shared library
        ADD_EXECUTABLE(${EX_ROOT} ${EX_PROG})
	IF(GUI_NAME)
	    ADD_DEPENDENCIES(${EX_ROOT} ${GUI_NAME})
	ENDIF()
        SET_TARGET_PROPERTIES(${EX_ROOT}
		PROPERTIES
	      PROJECT_LABEL "Example - ${EX_ROOT}")
        TARGET_LINK_LIBRARIES(${EX_ROOT} ${TEST_SHARED_TARGET})

	INSTALL(TARGETS ${EX_ROOT} DESTINATION examples/molmodel/bin)
    ENDIF()

    IF (BUILD_STATIC_LIBRARIES AND BUILD_TESTING_STATIC)
        # Link with static library
        SET(EX_STATIC ${EX_ROOT}Static)
        ADD_EXECUTABLE(${EX_STATIC} ${EX_PROG})
	IF(GUI_NAME)
	    ADD_DEPENDENCIES(${EX_STATIC} ${GUI_NAME})
	ENDIF()
        SET_TARGET_PROPERTIES(${EX_STATIC}
		PROPERTIES
		COMPILE_FLAGS "-DSimTK_USE_STATIC_LIBRARIES"
		PROJECT_LABEL "Example - ${EX_STATIC}")
        TARGET_LINK_LIBRARIES(${EX_STATIC} ${TEST_STATIC_TARGET})
	# Don't install static examples
    ENDIF()

ENDFOREACH()

# Copy extra files associated with these examples
# to the binary directory that will be the working
# directory when the tests are run; and include them in
# the examples installation. ".obj" files contain geometry.
FILE(GLOB EXTRA_FILES "*.obj" "*.pdb" "*.vmd")
FOREACH(XTRA ${EXTRA_FILES})
    GET_FILENAME_COMPONENT(XTRA_ROOT ${XTRA} NAME)
    CONFIGURE_FILE(${XTRA} 
	           ${CMAKE_CURRENT_BINARY_DIR}/${XTRA_ROOT} COPYONLY)
    INSTALL(FILES ${XTRA} DESTINATION examples/molmodel/src)
    INSTALL(FILES ${XTRA} DESTINATION examples/molmodel/bin)
ENDFOREACH()

# install source for examples
FILE(GLOB SRC_FILES "*.cpp" "*.h")
INSTALL(FILES ${SRC_FILES} DESTINATION examples/molmodel/src)

# install .txt files except CMakeLists.txt
FILE(GLOB TXT_FILES "*.txt")
FOREACH(TXTF ${TXT_FILES})
    IF(NOT "${TXTF}" MATCHES "CMakeLists.txt")
	INSTALL(FILES ${TXTF} DESTINATION examples/molmodel/src)
    ENDIF()
ENDFOREACH()

# install the installed version of CMakeLists.txt
INSTALL(FILES InstalledCMakeLists.txt DESTINATION examples/molmodel/src
	RENAME CMakeLists.txt)

# install Makefile
INSTALL(FILES "${PROJECT_SOURCE_DIR}/examples/Makefile"
    DESTINATION examples/molmodel/src)

=== examples/Makefile ===
# Makefile for building Molmodel examples on Linux or Mac.
# See README_Makefile.txt for more information.
 
# Comment this out if you're building 64 bit examples (Linux only).
# One more change required also -- see lib64 below.
M32FLAG = -m32

# Uncomment DEBUG to use Simbody debug libraries instead of release libraries
# DEBUG=_d

# Default install directory
# SimTK_INSTALL_DIR=/usr/local/SimTK
#
ifeq "${SimTK_INSTALL_DIR}" ""
SimTK_HOME=/usr/local/SimTK
else
SimTK_HOME=${SimTK_INSTALL_DIR}
endif

# Change this to lib64 if you're build 64 bit examples (Linux only).
LIB_DIR=$(SimTK_HOME)/lib
INCLUDE_DIR=$(SimTK_HOME)/include

# You would need this whole list to link with static libraries; for 
# dynamic libraries (shared objects) the others are picked up as needed.
#       -llapack -lblas -lpthread -lm -lrt
LIBS= -lSimTKmolmodel$(DEBUG) -lSimTKsimbody$(DEBUG) \
      -lSimTKmath$(DEBUG) -lSimTKcommon$(DEBUG)

ifeq "${DEBUG}" ""
CFLAGS = -O2 ${M32FLAG}
else
CFLAGS = -g ${M32FLAG}
endif

ALL_PROGS = \
MolmodelInstallTestNoViz \
MolmodelInstallTest \
ExampleAdenylateMobilitiesViz \
ExampleAdenylateMobilitiesVMD \
ExampleCreatePropane \
ExampleFoldPolyalanine \
ExampleLoadPdb \
ExampleLoadPdb2 \
ExampleRigidProtein \
ExampleSimpleProtein \
ExampleSimpleRNA \
ExampleTwoArgonAtoms \
ExampleTwoEthanes 

default: MolmodelInstallTestNoViz MolmodelInstallTest
	@echo Using $(SimTK_HOME) as the SimTK installation directory.


all : $(ALL_PROGS)
	@echo Using $(SimTK_HOME) as the SimTK installation directory.

# Treat all .cpp source files the same way
.cpp : 
	g++ $(CFLAGS) $< -I$(INCLUDE_DIR) -L$(LIB_DIR) $(LIBS) -o $*

clean : 
	rm $(ALL_PROGS)

=== rna-dynamics/Makefile ===
%.exe : %.o Makefile
	/usr/bin/c++      -Wno-deprecated   -g -headerpad_max_install_names -fPIC  $< -o $@ -L/usr/local/lib  -L$$DYLD_LIBRARY_PATH  -lSimTKsimbody  -lpthread -lm -lSimTKmolmodel -lSimTKsimbody -lSimTKmath -lSimTKcpodes -lSimTKcommon -lSimTKlapack -lpthread



#                               list of dependencies
%.o  :  %.cpp
	export DYLD_LIBRARY_PATH=$$SIMTK_PREFIX/lib
	/usr/bin/c++   -Wno-deprecated   -g -I$$SIMTK_PREFIX/include/molmodel/internal -I$$SIMTK_PREFIX/include -c  $<
	#/usr/bin/c++   -Wno-deprecated -no-cpp-precomp  -g -I/Users/samuelflores/svn/molmodel/include/molmodel/internal -I$$SIMTK_PREFIX/include  -c  $<

=== sharedTarget/CMakeLists.txt ===
## This whole directory exists just so I could define this extra 
## preprocessor value.
ADD_DEFINITIONS(-DSimTK_MOLMODEL_BUILDING_SHARED_LIBRARY)

IF(BUILD_UNVERSIONED_LIBRARIES)

    # These are dependencies so we know when we have to rebuild.
    ADD_LIBRARY(${SHARED_TARGET} SHARED 
                ${SOURCE_FILES} 
                ${SOURCE_INCLUDE_FILES} 
                ${API_ABS_INCLUDE_FILES})
    
    TARGET_LINK_LIBRARIES(${SHARED_TARGET} 
	${Simbody_LIBRARIES}
        ${ADDITIONAL_LINK_LIBRARIES})
    
    SET_TARGET_PROPERTIES(${SHARED_TARGET} PROPERTIES
    	PROJECT_LABEL "Library - ${SHARED_TARGET}"
        SOVERSION "${MOLMODEL_MAJOR_VERSION}.${MOLMODEL_MINOR_VERSION}")
    
    # install library; on Windows .dll goes in the bin directory.
    INSTALL_TARGETS(/lib${LIB64} 
    		    RUNTIME_DIRECTORY /bin
                    ${SHARED_TARGET})

ENDIF(BUILD_UNVERSIONED_LIBRARIES)



IF(BUILD_VERSIONED_LIBRARIES)

    # These are dependencies so we know when we have to rebuild.
    ADD_LIBRARY(${SHARED_TARGET_VN} SHARED 
                ${SOURCE_FILES} 
                ${SOURCE_INCLUDE_FILES} 
                ${API_ABS_INCLUDE_FILES})
    
    TARGET_LINK_LIBRARIES(${SHARED_TARGET_VN} 
	${Simbody_LIBRARIES_VN}
        ${ADDITIONAL_LINK_LIBRARIES})
    
    SET_TARGET_PROPERTIES(${SHARED_TARGET_VN} PROPERTIES
    	PROJECT_LABEL "Library - ${SHARED_TARGET_VN}")
    
    # install library; on Windows .dll goes in the bin directory.
    INSTALL_TARGETS(/lib${LIB64} 
    		    RUNTIME_DIRECTORY /bin
                    ${SHARED_TARGET_VN})

ENDIF(BUILD_VERSIONED_LIBRARIES)

=== staticTarget/CMakeLists.txt ===
## This whole directory exists just so I could define these extra 
## preprocessor values.
ADD_DEFINITIONS(
  -DSimTK_MOLMODEL_BUILDING_STATIC_LIBRARY 
  -DSimTK_USE_STATIC_LIBRARIES)

IF(BUILD_UNVERSIONED_LIBRARIES)

    # This is the list of dependencies so we know when to rebuild.
    ADD_LIBRARY(${STATIC_TARGET} STATIC 
                ${SOURCE_FILES} 
                ${SOURCE_INCLUDE_FILES} 
                ${API_ABS_INCLUDE_FILES})
    
    TARGET_LINK_LIBRARIES(${STATIC_TARGET}
	${Simbody_STATIC_LIBRARIES}
        ${ADDITIONAL_LINK_LIBRARIES})
    
    SET_TARGET_PROPERTIES(${STATIC_TARGET} PROPERTIES
    	PROJECT_LABEL "Library - ${STATIC_TARGET}")
    
    # install library; on Windows .dll goes in the bin directory.
    INSTALL_TARGETS(/lib${LIB64} 
                    RUNTIME_DIRECTORY /bin
                    ${STATIC_TARGET})

ENDIF(BUILD_UNVERSIONED_LIBRARIES)



IF(BUILD_VERSIONED_LIBRARIES)

    # This is the list of dependencies so we know when to rebuild.
    ADD_LIBRARY(${STATIC_TARGET_VN} STATIC 
                ${SOURCE_FILES} 
                ${SOURCE_INCLUDE_FILES} 
                ${API_ABS_INCLUDE_FILES})
    
    TARGET_LINK_LIBRARIES(${STATIC_TARGET_VN}
	${Simbody_STATIC_LIBRARIES_VN}
        ${ADDITIONAL_LINK_LIBRARIES})
    
    SET_TARGET_PROPERTIES(${STATIC_TARGET_VN} PROPERTIES
    	PROJECT_LABEL "Library - ${STATIC_TARGET_VN}")
    
    # install library; on Windows .dll goes in the bin directory.
    INSTALL_TARGETS(/lib${LIB64} 
                    RUNTIME_DIRECTORY /bin
                    ${STATIC_TARGET_VN})

ENDIF(BUILD_VERSIONED_LIBRARIES)

=== tests/CMakeLists.txt ===
# Adhoc tests are those test or demo programs which are not intended,
# or not ready, to be part of the regression suite.
ADD_SUBDIRECTORY(adhoc)

# Generate regression tests.
#
# This is boilerplate code for generating a set of executables, one per
# .cpp file in a "tests" directory. These are for test cases which 
# have been engineered to be suitable as part of the nightly regression
# test suite. Ideally, they know their correct answers and return
# a simple thumbs-up/thumbs-down result, although some regressions 
# may be present and useful just to determine if they compile and
# run to completion.
#
# For IDEs that can deal with PROJECT_LABEL properties (at least
# Visual Studio) the projects for building each of these adhoc
# executables will be labeled "Regr - TheTestName" if a file
# TheTestName.cpp is found in this directory.
#
# We check the BUILD_TESTING_{SHARED,STATIC} variables to determine
# whether to build dynamically linked, statically linked, or both
# versions of the executable.

FILE(GLOB REGR_TESTS "*.cpp")
FOREACH(TEST_PROG ${REGR_TESTS})
    GET_FILENAME_COMPONENT(TEST_ROOT ${TEST_PROG} NAME_WE)

    # Some test programs may require an argument
    SET(TEST_ARGS "")
    IF(${TEST_ROOT} MATCHES "TestLoadPdb")
        SET(TEST_ARGS "${CMAKE_SOURCE_DIR}/resources/structures/1FFK_rnafrag10.pdb")
    ENDIF(${TEST_ROOT} MATCHES "TestLoadPdb")

    IF (BUILD_TESTING_SHARED)
        # Link with shared library
        ADD_EXECUTABLE(${TEST_ROOT} ${TEST_PROG})
        SET_TARGET_PROPERTIES(${TEST_ROOT}
		PROPERTIES
	      PROJECT_LABEL "Test_Regr - ${TEST_ROOT}")
        TARGET_LINK_LIBRARIES(${TEST_ROOT} 
					${TEST_SHARED_TARGET})
        ADD_TEST(${TEST_ROOT} ${EXECUTABLE_OUTPUT_PATH}/${TEST_ROOT} ${TEST_ARGS})
    ENDIF()

    IF (BUILD_STATIC_LIBRARIES AND BUILD_TESTING_STATIC)
        # Link with static library
        SET(TEST_STATIC ${TEST_ROOT}Static)
        ADD_EXECUTABLE(${TEST_STATIC} ${TEST_PROG})
        SET_TARGET_PROPERTIES(${TEST_STATIC}
		PROPERTIES
		COMPILE_FLAGS "-DSimTK_USE_STATIC_LIBRARIES"
		PROJECT_LABEL "Test_Regr - ${TEST_STATIC}")
        TARGET_LINK_LIBRARIES(${TEST_STATIC}
					${TEST_STATIC_TARGET})
        ADD_TEST(${TEST_STATIC} ${EXECUTABLE_OUTPUT_PATH}/${TEST_STATIC} ${TEST_ARGS})
    ENDIF()

ENDFOREACH(TEST_PROG ${REGR_TESTS})

=== debian/changelog ===
molmodel (3.0~svn842-2) unstable; urgency=medium

  * Adding 'Rules-Requires-Root: no'.
  * Bumping debhelper-compat.
  * Not installing examples for now.
  * Installing docs.

 -- Andrius Merkys <merkys@debian.org>  Wed, 17 Jun 2020 07:21:24 -0400

molmodel (3.0~svn842-1) unstable; urgency=medium

  * Initial release (Closes: #962029)

 -- Andrius Merkys <merkys@debian.org>  Thu, 04 Jun 2020 08:35:56 -0400

=== debian/control ===
Source: molmodel
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libmmdb2-dev,
 libsimbody-dev,
Standards-Version: 4.5.0
Section: libs
Homepage: https://simtk.org/projects/molmodel
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debichem-team/molmodel
Vcs-Git: https://salsa.debian.org/debichem-team/molmodel.git

Package: libsimtkmolmodel-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libsimtkmolmodel3.0 (= ${binary:Version}),
 ${misc:Depends},
Description: C++ API for creating molecular models for SimTK (development files)
 Provides C++ API for creating molecular models whose dynamics can be simulated
 using the SimTK Simbody library. Molmodel is a programmer's toolkit for
 building reduced-coordinate, yet still all-atom, models of large biopolymers
 such as proteins, RNA, and DNA. One can control the allowed mobility. By
 default, Molmodel builds torsion-coordinate models in which bond stretch and
 bend angles are rigid while bond torsion angles are mobile. But one is able
 to rigidify or free any subsets of the atoms, such as the rigid benzene ring.
 .
 Molmodel is a C++ API for biochemist-friendly molecular modeling that extends
 the Simbody API to simplify construction of high-performance articulated models
 of molecules.
 .
 This package contains development files.

Package: libsimtkmolmodel3.0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: C++ API for creating molecular models for SimTK
 Provides C++ API for creating molecular models whose dynamics can be simulated
 using the SimTK Simbody library. Molmodel is a programmer's toolkit for
 building reduced-coordinate, yet still all-atom, models of large biopolymers
 such as proteins, RNA, and DNA. One can control the allowed mobility. By
 default, Molmodel builds torsion-coordinate models in which bond stretch and
 bend angles are rigid while bond torsion angles are mobile. But one is able
 to rigidify or free any subsets of the atoms, such as the rigid benzene ring.
 .
 Molmodel is a C++ API for biochemist-friendly molecular modeling that extends
 the Simbody API to simplify construction of high-performance articulated models
 of molecules.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# Most of the tests fail (confirmed by the upstream)
override_dh_auto_test:

override_dh_install:
	dh_install
	dh_install -plibsimtkmolmodel3.0  debian/tmp/usr/lib/libSimTKmolmodel.so.* usr/lib/${DEB_HOST_MULTIARCH}
	dh_install -plibsimtkmolmodel-dev debian/tmp/usr/lib/libSimTKmolmodel.so   usr/lib/${DEB_HOST_MULTIARCH}
	rm -rf debian/tmp/usr/examples # not installing examples for now

=== debian/watch ===
version=4
opts="mode=svn,pgpmode=none,uversionmangle=s/^0\.0/3.0/" \
 https://simtk.org/svn/molmodel/trunk HEAD

## molmodel 3.0.113.gd05a5b6

=== CMakeLists.txt ===
#---------------------------------------------------
# Molmodel
#
# Creates SimTK library, base name=SimTKmolmodel.
# Default libraries are shared & optimized. Variants
# are created for static (_static) and debug (_d) and
# provision is made for an optional "namespace" (ns)
# and version number (vn).
#
# Windows:
#   [ns_]SimTKmolmodel[_vn][_d].dll
#   [ns_]SimTKmolmodel[_vn][_d].lib
#   [ns_]SimTKmolmodel[_vn]_static[_d].lib
# Unix:
#   lib[ns_]SimTKmolmodel[_vn][_d].so
#   lib[ns_]SimTKmolmodel[_vn]_static[_d].a
#
# All libraries are installed in
#   %ProgramFiles%\SimTK\lib    (Windows)
#   /usr/local/SimTK/lib[64]    (Linux, Mac)
#
# Also creates an OpenMM plugin DLL that is used at
# runtime to determine whether OpenMM is available.
# That DLL is named
#   OpenMMPlugin[_d].dll
#   libOpenMMPlugin[_d].so
#   libOpenMMPlugin[_d].dylib
# And there is no static version.
#----------------------------------------------------

CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT(Molmodel)

SET(MOLMODEL_MAJOR_VERSION 3)
SET(MOLMODEL_MINOR_VERSION 0)
SET(MOLMODEL_PATCH_VERSION 0)

SET(MOLMODEL_COPYRIGHT_YEARS "2006-12")

# underbar separated list of dotted authors, no spaces or commas
SET(MOLMODEL_AUTHORS "Christopher.Bruns_Michael.Sherman")
SET(CMAKE_CXX_STANDARD 14)
SET(CMAKE_CXX_EXTENSIONS OFF)

# Report the version number to the CMake UI. Don't include the
# build version if it is zero.
SET(PATCH_VERSION_STRING)
IF(MOLMODEL_PATCH_VERSION)
    SET(PATCH_VERSION_STRING ".${MOLMODEL_PATCH_VERSION}")
ENDIF()

SET(MOLMODEL_VERSION
    "${MOLMODEL_MAJOR_VERSION}.${MOLMODEL_MINOR_VERSION}${PATCH_VERSION_STRING}"
    CACHE STRING
    "This is the version that will be built (can't be changed here)."
    FORCE)

# This is the suffix if we're building and depending on versioned libraries.
SET(VN "_${MOLMODEL_VERSION}")

SET(BUILD_BINARY_DIR ${CMAKE_BINARY_DIR}
    CACHE PATH
    "The Molmodel build (not the install) puts all the libraries and executables together here (with /Release, etc. appended on some platforms).")

# Make everything go in the same binary directory. (These are CMake-defined
# variables.)
SET(EXECUTABLE_OUTPUT_PATH ${BUILD_BINARY_DIR})
SET(LIBRARY_OUTPUT_PATH ${BUILD_BINARY_DIR})

SET(BUILD_SHARED_LIBRARIES TRUE CACHE BOOL
    "Build dynamically linked (shared) version of the libraries")

# Static libraries, tests, and examples won't be built unless this
# is SET.
SET(BUILD_STATIC_LIBRARIES FALSE CACHE BOOL
    "Build '_static' versions of the libraries libraries?")
IF((NOT ${BUILD_SHARED_LIBRARIES}) AND (NOT ${BUILD_STATIC_LIBRARIES}))
    MESSAGE(FATAL_ERROR "Neither shared nor static build has been enabled. Aborting")
ENDIF()

# Use this to generate a private SET of libraries whose names
# won't conflict with installed versions.
SET(BUILD_USING_NAMESPACE "" CACHE STRING
	"All library names will be prefixed with 'xxx_' if this is SET to xxx.")

SET(BUILD_UNVERSIONED_LIBRARIES TRUE CACHE BOOL
    "Build library names, and assume dependency names, with no version numbers?")

SET(BUILD_VERSIONED_LIBRARIES FALSE CACHE BOOL
    "Build library names, and assume dependency names, with version numbers?")

SET(GEMMI_PATH "" CACHE PATH "Where is the Gemmi library installed?")

IF(WIN32)
    SET(zlib_INSTALL_DIR "" CACHE PATH
	    "Where to find zlib files")
ENDIF()

SET(NS)
IF(BUILD_USING_NAMESPACE)
    SET(NS "${BUILD_USING_NAMESPACE}_")
ENDIF()

SET(MOLMODEL_LIBRARY_NAME ${NS}SimTKmolmodel CACHE STRING
    "Base name of the library being built; can't be changed here; see BUILD_USING_NAMESPACE variable."
    FORCE)


# Permit use of custom FindOpenMM and FindSimbody modules
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake_modules")
SET(CMAKE_VERBOSE_MAKEFILE OFF CACHE BOOL "Control volume of build output" )

SET(OpenMM_ON OFF)
FIND_PACKAGE(OpenMM)
IF(OpenMM_FOUND)
    SET(OpenMM_ON ON)
ENDIF()
SET(MOLMODEL_USE_OpenMM ${OpenMM_ON} CACHE BOOL
    "Control whether Molmodel builds the OpenMM Plugin (requires that OpenMM is installed on the build machine)." )

# Caution: this variable is automatically created by the CMake
# ENABLE_TESTING() command, but we'll take it over here for
# our own purposes too.
SET(BUILD_TESTING ON CACHE BOOL
	"Control building of Molmodel test programs.")

SET(BUILD_EXAMPLES ON CACHE BOOL
	"Control building of Molmodel example programs.")
# Turning this off reduces the build time (and space) substantially,
# but you may miss the occasional odd bug. Also currently on Windows it
# is easier to debug the static tests than the DLL-liked ones.
SET(BUILD_TESTING_STATIC ON CACHE BOOL
    "If building static libraries, build static test and example programs too?")

SET(BUILD_TESTING_SHARED ON CACHE BOOL
    "If building test or example programs, include dynamically-linked ones?" )
# Create a platform name useful for some platform-specific stuff.

IF(WIN32)
    SET(NATIVE_COPY_CMD copy)
ELSEIF(APPLE)
    SET(NATIVE_COPY_CMD cp)
ELSE()
    SET(NATIVE_COPY_CMD cp)
ENDIF()

# In addition to the platform name we need to know the Application Binary
# Interface (ABI) we're building for. Currently that is either x86, meaning
# 32 bit Intel instruction SET, or x64 for 64 bit Intel instruction SET.
IF(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
    SET(PLATFORM_ABI x64)
ELSE()
    SET(PLATFORM_ABI x86)
ENDIF()

IF(WIN32)
    ADD_DEFINITIONS(-DNOMINMAX -DWIN32_LEAN_AND_MEAN -D_USE_MATH_DEFINES -D_WIN32_WINNT=0x0501)

	IF(MSVC)
	    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
	ENDIF()
ENDIF()

SET(BUILD_PLATFORM "${CMAKE_HOST_SYSTEM_NAME}:${PLATFORM_ABI}" CACHE STRING
    "This is the platform and ABI we're building for. Not changeable here; use a different CMake generator instead."
    FORCE)

# Find Simbody using the local FindSimbody.cmake if present.
find_package(Simbody REQUIRED)
include_directories(${Simbody_INCLUDE_DIR})
link_directories(${Simbody_LIB_DIR})

IF(WIN32)
    IF (zlib_INSTALL_DIR STREQUAL "")
        MESSAGE(FATAL_ERROR "Path to zlib is not set")
	ENDIF()

	INCLUDE_DIRECTORIES(${zlib_INSTALL_DIR}/include)
	LINK_DIRECTORIES(${zlib_INSTALL_DIR}/lib)
ENDIF()

# If CMAKE_INSTALL_PREFIX is /usr/local, then the LIBDIR should necessarily be
# lib/. Sometimes (on Linux), LIBDIR is something like x86_64-linux-gnu. The
# linker will search /usr/lib/x86_64-linux-gnu (this path is in
# HOWEVER, it WILL search /usr/local/lib. So that Linux users needn't modify
# their LD_LIBRARY_PATH if installing to /usr/local, we force the LIBDIR to be
# lib/.
# Note: CMake 3.0 fixes this issue. When we move to CMake 3.0, we can
# remove this if-statement. See issue #151.
IF("${CMAKE_INSTALL_PREFIX}" STREQUAL "/usr/local" OR
   "${CMAKE_INSTALL_PREFIX}" STREQUAL "/usr/local/")
    # Overwrite both of these variables; we use both of them.
    SET(CMAKE_INSTALL_LIBDIR "lib")
    SET(CMAKE_INSTALL_FULL_LIBDIR
        "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
ENDIF()


IF(NOT MSVC AND NOT XCODE AND NOT CMAKE_BUILD_TYPE)
    SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
        "Debug, RelWithDebInfo (recommended), or Release build"
        FORCE)
ENDIF()

## Choose the maximum level of x86 instruction SET that the compiler is
## allowed to use.
## Was using sse2 but changed to let the compilers choose. Most will
## probably use sse2 or later by default.
## On 64 bit MSVC 2013, the default is sse2 and the argument
## isn't recognized so don't specify it.
IF(CMAKE_CL_64)
    SET(default_build_inst_SET)
ELSE()
    SET(default_build_inst_SET)
ENDIF()

## This can be SET to a different value by the person running CMake.
SET(BUILD_INST_SET ""
    CACHE STRING
    "CPU instruction level compiler is permitted to use (default: let compiler decide).")
MARK_AS_ADVANCED(BUILD_INST_SET)

IF(BUILD_INST_SET)
    SET(inst_SET_to_use ${BUILD_INST_SET})
ELSE()
    SET(inst_SET_to_use ${default_build_inst_SET})
ENDIF()


## When building in any of the Release modes, tell VC++ cl compiler to use
## intrinsics (i.e. sqrt instruction rather than sqrt subroutine) with
## flag /Oi.
## Caution: can't use CMAKE_CXX_COMPILER_ID MATCHES MSVC here because
## "MSVC" is a predefined CMAKE variable and will get expanded to 1 or 0
IF(MSVC)
    IF(inst_SET_to_use)
        STRING(TOUPPER ${inst_SET_to_use} CL_INST_SET)
        SET(CL_INST_SET "/arch:${CL_INST_SET}")
    ELSE()
        SET(CL_INST_SET)
    ENDIF()

    SET(BUILD_LIMIT_PARALLEL_COMPILES "" CACHE STRING
        "Set a maximum number of simultaneous compilations.")
    MARK_AS_ADVANCED(BUILD_LIMIT_PARALLEL_COMPILES)
    SET(mxcpu ${BUILD_LIMIT_PARALLEL_COMPILES}) # abbreviation

    ## C++
    SET(BUILD_CXX_FLAGS_DEBUG
        "/D _DEBUG /MDd /Od /Ob0 /RTC1 /Zi /GS- ${CL_INST_SET}")
    SET(BUILD_CXX_FLAGS_RELEASE
        "/D NDEBUG /MD  /O2 /Ob2 /Oi /GS- ${CL_INST_SET}")
    SET(BUILD_CXX_FLAGS_RELWITHDEBINFO
        "/D NDEBUG /MD  /O2 /Ob2 /Oi /Zi /GS- ${CL_INST_SET}")
    SET(BUILD_CXX_FLAGS_MINSIZEREL
        "/D NDEBUG /MD  /O1 /Ob1 /Oi /GS- ${CL_INST_SET}")

    SET(CMAKE_CXX_FLAGS_DEBUG "/MP${mxcpu} ${BUILD_CXX_FLAGS_DEBUG}"
        CACHE STRING "Can't change here -- see BUILD_CXX..." FORCE)
    SET(CMAKE_CXX_FLAGS_RELEASE "/MP${mxcpu} ${BUILD_CXX_FLAGS_RELEASE}"
        CACHE STRING "Can't change here -- see BUILD_CXX..." FORCE)
    SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "/MP${mxcpu} ${BUILD_CXX_FLAGS_RELWITHDEBINFO}"
        CACHE STRING "Can't change here -- see BUILD_CXX..." FORCE)
    SET(CMAKE_CXX_FLAGS_MINSIZEREL "/MP${mxcpu} ${BUILD_CXX_FLAGS_MINSIZEREL}"
        CACHE STRING "Can't change here -- see BUILD_CXX..." FORCE)
ENDIF()

# The source is organized into subdirectories, but we handle them all from
# this CMakeLists file rather than letting CMake visit them as SUBDIRS.
SET(MOLMODEL_SOURCE_SUBDIRS .)


# Collect up information about the version of the molmodel library we're building
# and make it available to the code so it can be built into the binaries.

# Get the subversion revision number if we can
# It's possible that WIN32 installs use svnversion through cygwin
# so we'll try for both svnversion.exe and svnversion. Note that
# this will result in warnings if all you have is Tortoise without
# Cygwin, and your "about" string will say "unknown" rather than
# providing the SVN version of the source.

# If there is an actual reason for the SVNVERSION vs. SVNVERSION_EXE
# nonsense that was here before, come talk to me.  --Chris Bruns
# 1) CMake already understands that Windows executables have ".exe" at the end.
# 2) Providing a PATHS argument to find_program is *NOT* hard coding a single path.
# Please read the CMake documentation for more details.
FIND_PROGRAM(SVNVERSION_EXECUTABLE svnversion PATHS "C:/cygwin/bin")

IF(SVNVERSION_EXECUTABLE)
    EXEC_PROGRAM(${SVNVERSION_EXECUTABLE}
              # Works better on Windows to SET working directory rather than
              # passing argument to svnversion
                 ${CMAKE_SOURCE_DIR} # cwd for run
                 OUTPUT_VARIABLE OUT)
    SET(MOLMODEL_SVN_REVISION "${OUT}" CACHE STRING "Molmodel svn revision number" FORCE)
ELSE(SVNVERSION_EXECUTABLE)
    MESSAGE(STATUS
            "Could not find 'svnversion' executable; 'about' will be wrong. (Cygwin provides one on Windows.)")
    SET(MOLMODEL_SVN_REVISION "unknown" CACHE STRING "Molmodel svn revision number")
ENDIF(SVNVERSION_EXECUTABLE)
MARK_AS_ADVANCED(MOLMODEL_SVN_REVISION)

# Remove colon from build version, for easier placement in directory names
STRING(REPLACE ":" "_" MOLMODEL_SVN_REVISION ${MOLMODEL_SVN_REVISION})

ADD_DEFINITIONS(-DSimTK_MOLMODEL_LIBRARY_NAME=${MOLMODEL_LIBRARY_NAME}
                -DSimTK_MOLMODEL_MAJOR_VERSION=${MOLMODEL_MAJOR_VERSION}
                -DSimTK_MOLMODEL_MINOR_VERSION=${MOLMODEL_MINOR_VERSION}
                -DSimTK_MOLMODEL_PATCH_VERSION=${MOLMODEL_PATCH_VERSION})

# CMake quotes automatically when building Visual Studio projects but we need
# to add them ourselves for Linux or Cygwin. Two cases to avoid duplicate quotes

=== OpenMMPlugin/CMakeLists.txt ===
--- 
+++ 
@@ -6,20 +6,40 @@
 
 # The library is dependent on its local .cpp file and some of
 # the Molmodel classes. We'll list everything to be safe.
-ADD_LIBRARY(OpenMMPlugin SHARED 
-	OpenMMPlugin.cpp
-    ${SOURCE_INCLUDE_FILES} 
-	${API_ABS_INCLUDE_FILES})
+
+IF (OpenMM_STATIC_LIBRARY)
+    ADD_LIBRARY(OpenMMPlugin STATIC
+        OpenMMPlugin.cpp
+        ${SOURCE_INCLUDE_FILES}
+        ${API_ABS_INCLUDE_FILES})
+ELSE ()
+    ADD_LIBRARY(OpenMMPlugin SHARED
+        OpenMMPlugin.cpp
+        ${SOURCE_INCLUDE_FILES}
+        ${API_ABS_INCLUDE_FILES})
+ENDIF ()
+
 IF (UNIX AND CMAKE_BUILD_TYPE MATCHES Debug)
     set_target_properties(OpenMMPlugin PROPERTIES DEBUG_POSTFIX "_d")
 ENDIF (UNIX AND CMAKE_BUILD_TYPE MATCHES Debug)
 
 # The plugin depends on the OpenMM.dll that is part of
-# the OpenMM distribution. 
-TARGET_LINK_LIBRARIES(OpenMMPlugin
-  ${SHARED_TARGET}			   # SimTKMolmodel.dll
-  ${OpenMM_LIBRARIES})
+# the OpenMM distribution.
 
+IF (BUILD_UNVERSIONED_LIBRARIES)
+    TARGET_LINK_LIBRARIES(OpenMMPlugin
+        ${SHARED_TARGET}			   # SimTKMolmodel.dll
+		SimTKcommon
+        ${OpenMM_LIBRARIES})
+ELSEIF(BUILD_VERSIONED_LIBRARIES)
+    TARGET_LINK_LIBRARIES(OpenMMPlugin
+        ${SHARED_TARGET_VN}			   # SimTKMolmodel.dll
+		SimTKcommon_${Simbody_VERSION}
+        ${OpenMM_LIBRARIES})
+ELSE()
+    MESSAGE(FATAL_ERROR "SimTKmolmodel was not configured to build")
+ENDIF()
+    
 SET_TARGET_PROPERTIES(OpenMMPlugin PROPERTIES
 	PROJECT_LABEL "Plugin - OpenMMPlugin")

=== sharedTarget/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,13 @@
 ## This whole directory exists just so I could define this extra 
 ## preprocessor value.
 ADD_DEFINITIONS(-DSimTK_MOLMODEL_BUILDING_SHARED_LIBRARY)
+
+IF(UNIX)
+    IF(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU" OR
+       ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
+           SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
+    ENDIF()
+ENDIF()
 
 IF(BUILD_UNVERSIONED_LIBRARIES)
 
@@ -10,10 +17,17 @@
                 ${SOURCE_INCLUDE_FILES} 
                 ${API_ABS_INCLUDE_FILES})
     
-    TARGET_LINK_LIBRARIES(${SHARED_TARGET} 
-	${Simbody_LIBRARIES}
-        ${ADDITIONAL_LINK_LIBRARIES})
-    
+	IF (WIN32)
+        TARGET_LINK_LIBRARIES(${SHARED_TARGET} 
+            PRIVATE ${Simbody_LIBRARIES}
+            PRIVATE zdll
+			PRIVATE ws2_32)
+	ELSE()
+        TARGET_LINK_LIBRARIES(${SHARED_TARGET} 
+            PRIVATE ${Simbody_LIBRARIES}
+            PRIVATE z)
+	ENDIF()
+			
     SET_TARGET_PROPERTIES(${SHARED_TARGET} PROPERTIES
     	PROJECT_LABEL "Library - ${SHARED_TARGET}"
         SOVERSION "${MOLMODEL_MAJOR_VERSION}.${MOLMODEL_MINOR_VERSION}")
@@ -35,10 +49,17 @@
                 ${SOURCE_INCLUDE_FILES} 
                 ${API_ABS_INCLUDE_FILES})
     
-    TARGET_LINK_LIBRARIES(${SHARED_TARGET_VN} 
-	${Simbody_LIBRARIES_VN}
-        ${ADDITIONAL_LINK_LIBRARIES})
-    
+    IF (WIN32)
+        TARGET_LINK_LIBRARIES(${SHARED_TARGET_VN} 
+            PRIVATE ${Simbody_LIBRARIES}_${Simbody_VERSION}
+            PRIVATE zdll
+			PRIVATE ws2_32)
+    ELSE()
+            TARGET_LINK_LIBRARIES(${SHARED_TARGET_VN} 
+            PRIVATE ${Simbody_LIBRARIES}_${Simbody_VERSION}
+            PRIVATE z)
+    ENDIF()
+
     SET_TARGET_PROPERTIES(${SHARED_TARGET_VN} PROPERTIES
     	PROJECT_LABEL "Library - ${SHARED_TARGET_VN}")

=== staticTarget/CMakeLists.txt ===
--- 
+++ 
@@ -11,11 +11,18 @@
                 ${SOURCE_FILES} 
                 ${SOURCE_INCLUDE_FILES} 
                 ${API_ABS_INCLUDE_FILES})
-    
-    TARGET_LINK_LIBRARIES(${STATIC_TARGET}
-	${Simbody_STATIC_LIBRARIES}
-        ${ADDITIONAL_LINK_LIBRARIES})
-    
+ 
+   	IF(WIN32)
+        TARGET_LINK_LIBRARIES(${STATIC_TARGET} 
+            PRIVATE ${Simbody_LIBRARIES}
+            PRIVATE zlib
+			PRIVATE ws2_32)
+    ELSE()
+        TARGET_LINK_LIBRARIES(${STATIC_TARGET} 
+            PRIVATE ${Simbody_STATIC_LIBRARIES}
+            PRIVATE z)
+    ENDIF()
+
     SET_TARGET_PROPERTIES(${STATIC_TARGET} PROPERTIES
     	PROJECT_LABEL "Library - ${STATIC_TARGET}")
     
@@ -35,10 +42,17 @@
                 ${SOURCE_FILES} 
                 ${SOURCE_INCLUDE_FILES} 
                 ${API_ABS_INCLUDE_FILES})
-    
-    TARGET_LINK_LIBRARIES(${STATIC_TARGET_VN}
-	${Simbody_STATIC_LIBRARIES_VN}
-        ${ADDITIONAL_LINK_LIBRARIES})
+
+    IF(WIN32)
+        TARGET_LINK_LIBRARIES(${STATIC_TARGET_VN}
+	        PRIVATE ${Simbody_STATIC_LIBRARIES}_${Simbody_VERSION}
+            PRIVATE zlib
+			PRIVATE ws2_32)
+    ELSE()
+        TARGET_LINK_LIBRARIES(${STATIC_TARGET_VN}
+            PRIVATE ${Simbody_STATIC_LIBRARIES}_${Simbody_VERSION}
+            PRIVATE z)
+    ENDIF()
     
     SET_TARGET_PROPERTIES(${STATIC_TARGET_VN} PROPERTIES
     	PROJECT_LABEL "Library - ${STATIC_TARGET_VN}")

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,11 @@
     SET(TEST_ARGS "")
     IF(${TEST_ROOT} MATCHES "TestLoadPdb")
         SET(TEST_ARGS "${CMAKE_SOURCE_DIR}/resources/structures/1FFK_rnafrag10.pdb")
-    ENDIF(${TEST_ROOT} MATCHES "TestLoadPdb")
+    ELSEIF(${TEST_ROOT} MATCHES "TestNucleotide2")
+        SET(TEST_ARGS "${CMAKE_SOURCE_DIR}/resources/SantaLuciaParams/2MG/test.param")
+    ELSEIF(${TEST_ROOT} MATCHES "TestBiotypeSelfCode")
+        SET(TEST_ARGS "${CMAKE_SOURCE_DIR}/resources/tinker_amber99_clean.prm")
+    ENDIF()
 
     IF (BUILD_TESTING_SHARED)
         # Link with shared library
@@ -37,8 +41,8 @@
         SET_TARGET_PROPERTIES(${TEST_ROOT}
 		PROPERTIES
 	      PROJECT_LABEL "Test_Regr - ${TEST_ROOT}")
-        TARGET_LINK_LIBRARIES(${TEST_ROOT} 
-					${TEST_SHARED_TARGET})
+        TARGET_LINK_LIBRARIES(${TEST_ROOT}
+                              ${TEST_SHARED_TARGET})
         ADD_TEST(${TEST_ROOT} ${EXECUTABLE_OUTPUT_PATH}/${TEST_ROOT} ${TEST_ARGS})
     ENDIF()
 
@@ -51,7 +55,7 @@
 		COMPILE_FLAGS "-DSimTK_USE_STATIC_LIBRARIES"
 		PROJECT_LABEL "Test_Regr - ${TEST_STATIC}")
         TARGET_LINK_LIBRARIES(${TEST_STATIC}
-					${TEST_STATIC_TARGET})
+                              ${TEST_STATIC_TARGET})
         ADD_TEST(${TEST_STATIC} ${EXECUTABLE_OUTPUT_PATH}/${TEST_STATIC} ${TEST_ARGS})
     ENDIF()

=== debian/changelog ===
molmodel (3.0.113.gd05a5b6-1) unstable; urgency=medium

  * New upstream release 3.0.113.gd05a5b6.
  * Repository has moved to GitHub.
  * Dropping upstream-integrated patches.
  * Not building examples (they fail to build).
  * Build-depends on gemmi-dev.
  * Build depends on tao-pegtl-dev and zlib1g-dev (needed by gemmi-dev).
  * Bumping copyright years.

 -- Andrius Merkys <merkys@debian.org>  Fri, 26 Nov 2021 09:53:39 -0500

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,11 @@
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
+ gemmi-dev,
  libmmdb2-dev,
  libsimbody-dev,
+ tao-pegtl-dev,
+ zlib1g-dev,
 Standards-Version: 4.5.0
 Section: libs
 Homepage: https://simtk.org/projects/molmodel

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,9 @@
 
 %:
 	dh $@
+
+override_dh_auto_configure:
+	dh_auto_configure -- -DBUILD_EXAMPLES=OFF
 
 # Most of the tests fail (confirmed by the upstream)
 override_dh_auto_test:

=== debian/watch ===
version=4
opts="mode=git,pgpmode=none,pretty=describe,uversionmangle=s/^v//" \
 https://github.com/samuelflores/molmodel \
 HEAD
